#!/usr/bin/perl

##############################################################################
#                                                                            #
#  Dogsbody's Unreal Tournament 2003 Server Status                           #
#  Version 3.00                                                              #
#  Lasted Edited on 04 Jun 2003                                              #
#  Contact Dogsbody at dan@dogsbody.org                                      #
#                                                                            #
#  Description: A script to query a UT2003 server and respond to a webpage   #
#                                                                            #
##############################################################################
#                    EDIT BETWEEN HERE                     #
############################################################

# Please see the readme file for a description of these settings

$server = "gamer.dogsbody.org";
$port = "7777";
$queryport = "+10";
$timeout = "5";
$refresh = "60";
$title = "UT2003 Server Query";
$bgcolour = "#FFFFFF";
$fgcolour = "#000000";
$lncolour = "#0000FF";
$headerfile = "";
$footerfile = "";
$pictureurl = "http://www.dogsbody.org/ut2003/maps/MATCHTHIS.gif";
$script = "$ENV{SCRIPT_URI}";

############################################################
#                         AND HERE                         #
############################################################

use Socket;
use Sys::Hostname;


&header();
&query_server();
&convert_for_display();
&display();
&footer();
exit;


sub header
{
print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>$title</TITLE>\n";
print "<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"$refresh; URL=$script\">\n";
if (-e $headerfile)
 {
 open(HEADERFILE,$headerfile) || print "Can't open $headerfile\n";
 while (<HEADERFILE>)
  {print $_;}
 close (HEADERFILE);
 }
else
 {
 print "</HEAD>\n";
 print "<BODY BGCOLOR=\"$bgcolour\" TEXT=\"$fgcolour\" LINK=\"$lncolour\" ALINK=\"#FF0000\" VLINK=\"$lncolour\">\n";
 }
}


sub footer
{
if (-e $footerfile)
 {
 open(FOOTERFILE,$footerfile) || print "Can't open $footerfile\n";
 while (<FOOTERFILE>)
  {print $_;}
 close (FOOTERFILE);
 }
else
 {
 print "</BODY>\n";
 print "</HTML>\n";
 }
}

sub query_server
{
$protocol = getprotobyname 'udp';
$queryport = int($port) + int($queryport);
$ipaddr = inet_aton($server);
$portaddr = sockaddr_in($queryport, $ipaddr);
$intportaddr = sockaddr_in(0, gethostbyname(hostname()));
$timeout = int($timeout);
$query = "\x5c\x73\x74\x61\x74\x75\x73\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x55\x73\x65\x54\x72\x61\x6e\x73\x6c\x6f\x63\x61\x74\x6f\x72\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x46\x6f\x72\x63\x65\x52\x65\x73\x70\x61\x77\x6e\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x47\x61\x6d\x65\x4e\x61\x6d\x65\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x47\x61\x6d\x65\x53\x70\x65\x65\x64\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x4d\x61\x78\x53\x70\x65\x63\x74\x61\x74\x6f\x72\x73\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x4e\x75\x6d\x53\x70\x65\x63\x74\x61\x74\x6f\x72\x73\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x4c\x6f\x67\x67\x69\x6e\x67\x47\x61\x6d\x65\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x45\x6c\x61\x70\x73\x65\x64\x54\x69\x6d\x65\x5c\x5c\x6c\x65\x76\x65\x6c\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x4e\x65\x74\x4d\x6f\x64\x65\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72";
$query = $query . "\x74\x79\x5c\x67\x61\x6d\x65\x73\x74\x61\x74\x73\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x67\x6f\x61\x6c\x73\x63\x6f\x72\x65\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x74\x69\x6d\x65\x6c\x69\x6d\x69\x74\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x6d\x69\x6e\x70\x6c\x61\x79\x65\x72\x73\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x57\x65\x61\x70\x6f\x6e\x53\x74\x61\x79\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x47\x61\x6d\x65\x45\x6e\x64\x65\x64\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x57\x61\x69\x74\x69\x6e\x67\x54\x6f\x53\x74\x61\x72\x74\x4d\x61\x74\x63\x68\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x47\x61\x6d\x65\x44\x69\x66\x66\x69\x63\x75\x6c\x74\x79\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x4e\x75\x6d\x42\x6f\x74\x73\x5c\x5c\x67\x61\x6d\x65\x5f\x70\x72\x6f\x70\x65\x72\x74\x79\x5c\x62\x45\x6e\x61\x62\x6c\x65\x53\x74\x61\x74\x4c\x6f\x67\x67\x69\x6e\x67\x5c";
socket(SOCKET, PF_INET, SOCK_DGRAM, $protocol) || &error("Unable to create socket");
bind(SOCKET,$intportaddr) || &error("Unable to bind the socket");
send(SOCKET, $query, 0, $portaddr) || &error("Unable to send data to the UT server");
vec($rin, fileno(SOCKET), 1) = 1;
while (($response !~ /\\final\\$/) && select($rout = $rin, undef, undef, $timeout))
 {
 $svrportaddr = recv(SOCKET,$getback,2048,0) || &error("Unable to receive packets from the UT server, The server could be down");
 $response = $response . $getback;
 }
close(SOCKET);
if ($response eq "")
 {&error("No data was returned from the UT server, The server could be down");}
}


sub convert_for_display
{
@botlevels = ("Novice","Average","Experienced","Skilled","Adept","Masterful","Inhuman","Godlike");
@teamcolours = ("Red","Blue");

@raw = split(/\\/,$response);
foreach $bit1 (@raw)
 {
 if ($bit2)
  {
  $data{$bit2} = $bit1;
  if ($bit2 eq "queryid")
   {
   ($null,$dec) = split(/\./,$bit1);
   $packetcount++;
   if ($dec > $maxpackets) {$maxpackets = $dec;}
   }
  if ($bit2 =~ /^player\_/)
   {
   ($null,$dec) = split(/\_/,$bit2);
   if ($dec >= $countplayers) {$countplayers = $dec;}
   }
  $bit1 = "";
  }
 $bit2 = $bit1;
 }
if ($maxpackets > $packetcount)
 {
 &error("Not enough packets were received from the UT2003 server");
 }

$data{NetMode} =~ s/^NM_//;
$data{GameSpeed} = sprintf("%.2f",$data{GameSpeed});

#if ($data{bUseTranslocator}) {$data{bUseTranslocator} = "Yes";}
#else {$data{bUseTranslocator} = "No";}

if ($data{bWeaponStay} eq "True") {$data{bWeaponStay} = "Yes";}
elsif ($data{bWeaponStay} eq "False") {$data{bWeaponStay} = "No";}

if ($data{bForceRespawn} eq "True") {$data{bForceRespawn} = "Yes";}
elsif ($data{bForceRespawn} eq "False") {$data{bForceRespawn} = "No";}

if ($data{bEnableStatLogging} eq "True") {$data{bEnableStatLogging} = "Yes";}
elsif ($data{bEnableStatLogging} eq "False") {$data{bEnableStatLogging} = "No";}

if ($data{password} eq "0") {$data{password} = "No";}
elsif ($data{password} eq "1")
 {
 if ($data{AdminEMail} =~ /\@/) {$data{password} = "Yes <A HREF=\"mailto:$data{AdminEMail}\">E-mail admin for access</A>";}
 else {$data{password} = "Yes";}
 }

if ($data{GameName}) {$data{gametype} = $data{GameName};}

$data{GameDifficulty} = int($data{GameDifficulty});
if ($data{minplayers})
 {
 if ($data{bWaitingToStartMatch } eq "True") {$data{NumBots} = $data{minplayers};}
 $playersfoot = "<TR><TD ALIGN=center COLSPAN=4> Plus $data{NumBots} Bots of $botlevels[$data{GameDifficulty}] skill </TD></TR>";
 $botline = "$data{NumBots} of $data{minplayers} at $botlevels[$data{GameDifficulty}] skill";
 }
else {$botline = "None";}

if ($countplayers ne "")
 {
 for ($i = 0; $i <= $countplayers; $i++)
  {
  $player = "player_" . $i;
  $frags = "frags_" . $i;
  $ping = "ping_" . $i;
  $team = "team_" . $i;
  $line = "$data{$player}MATCHTHIS$data{$frags}MATCHTHIS$teamcolours[$data{$team}]MATCHTHIS$data{$ping}";
  push(@players,$line);
  }
 $sort = 1;
 @players = sort {(split(/MATCHTHIS/, $b))[$sort] <=> (split(/MATCHTHIS/, $a))[$sort];} @players;
 }

@highscore = split(/MATCHTHIS/,$players[0]);
if ($highscore[1]) {$highscore = $highscore[1];}
else {$highscore = "0";}

if ($data{goalscore} eq "0") {$data{goalscore} = "Unlimited";}

$tag = lc($data{mapname});
$pictureurl =~ s/MATCHTHIS/$tag/;

if ($data{ElapsedTime}) {$gamestatus = "Playing";}
elsif ($data{bWaitingToStartMatch} eq "True") {$gamestatus = "Waiting to start";}
elsif ($data{bGameEnded} eq "True") {$gamestatus = "Game just ended";}

@ElapsedTime = localtime($data{ElapsedTime});
$ElapsedTime[2]--;
if ($ElapsedTime[0]<10) {$ElapsedTime[0] = "0$ElapsedTime[0]";};
if ($ElapsedTime[1]<10) {$ElapsedTime[1] = "0$ElapsedTime[1]";};
if ($ElapsedTime[2] > 0) {$data{ElapsedTime} = "$ElapsedTime[2]:$ElapsedTime[1]:$ElapsedTime[0]";}
else {$data{ElapsedTime} = "$ElapsedTime[1]:$ElapsedTime[0]";}

if ($data{timelimit} eq "0") {$data{timelimit} = "Unlimited";}
else
 {
 $data{timelimit} = $data{timelimit} * 60;
 @timelimit = localtime($data{timelimit});
 $timelimit[2]--;
 if ($timelimit[1]<10) {$timelimit[1] = "0$timelimit[1]";};
 if ($timelimit[2] > 0) {$data{timelimit} = "$timelimit[2]:$timelimit[1]:00";}
 else {$data{timelimit} = "$timelimit[1]:00";}
 }
}


sub display
{
print qq!
<CENTER><FONT SIZE=6><B>$title</B></FONT>
<HR WIDTH=75% ALIGN=Center>
<BR>
<TABLE BORDER=0 WIDTH=100%>
<TR><TD ALIGN=center COLSPAN=2>

<TABLE BORDER=1>
<TR><TD ALIGN=center COLSPAN=2><B> The Server </B></TD></TR>
<TR><TD><B> Address </B></TD><TD> <A HREF=unreal://$server:$port>$server:$port</A> </TD></TR>
<TR><TD><B> Name </B></TD><TD> $data{hostname} </TD></TR>
<TR><TD><B> Admin name </B></TD><TD> $data{AdminName} </TD></TR>
<TR><TD><B> Admin mail </B></TD><TD> <A HREF=mailto:$data{AdminEMail}>$data{AdminEMail}</A> </TD></TR>
<TR><TD><B> Server Type </B></TD><TD> $data{NetMode} </TD></TR>
<TR><TD><B> Server Version  </B></TD><TD> $data{gamever} </TD></TR>
<TR><TD><B> Min Connect Ver </B></TD><TD> $data{minnetver} </TD></TR>
<TR><TD><B> Game Type </B></TD><TD> $data{gametype} </TD></TR>
<TR><TD><B> Game Stats </B></TD><TD> $data{bEnableStatLogging} </TD></TR>
<TR><TD><B> Game Speed </B></TD><TD> $data{GameSpeed} </TD></TR>
<\!-- <TR><TD><B> Use Translocator? </B></TD><TD> $data{bUseTranslocator} </TD></TR> -->
<TR><TD><B> Weapons Stay? </B></TD><TD> $data{bWeaponStay} </TD></TR>
<TR><TD><B> Force Respawn? </B></TD><TD> $data{bForceRespawn} </TD></TR>
<TR><TD><B> Req Password? </B></TD><TD> $data{password} </TD></TR>
</TABLE>
<BR>
<BR>

</TD></TR><TR><TD ALIGN=center>

<TABLE BORDER=1>
<TR><TD ALIGN=center COLSPAN=2><B> Current Map </B></TD></TR>
<TR><TD ALIGN=center COLSPAN=2><IMG SRC="$pictureurl"><BR><B> $data{maptitle} </B></TD></TR>
<TR><TD><B> Map File </B></TD><TD> $data{mapname} </TD></TR>
<TR><TD><B> Game Status </B></TD><TD> $gamestatus </TD></TR>
<TR><TD><B> Time </B></TD><TD> $data{ElapsedTime} of $data{timelimit} </TD></TR>
<TR><TD><B> Score </B></TD><TD> $highscore of $data{goalscore} </TD></TR>
<TR><TD><B> Players </B></TD><TD> $data{numplayers} of $data{maxplayers} </TD></TR>
<TR><TD><B> Spectators </B></TD><TD> $data{NumSpectators} of $data{MaxSpectators} </TD></TR>
<TR><TD><B> Bots </B></TD><TD> $botline </TD></TR>
</TABLE>

</TD><TD ALIGN=center>

<TABLE BORDER=1>
<TR><TD ALIGN=center COLSPAN=4><B> Current Players </B></TD></TR>
<TR ALIGN=center><TD><B> Name </B></TD><TD><B> Frags </B></TD><TD><B> Team </B></TD><TD><B> Ping </B></TD></TR>
!;
foreach $line (@players)
 {
 $line =~ s/MATCHTHIS/ \<\/TD\>\<TD\> /g;
 print "<TR><TD> $line </TD></TR>\n";
 }
print qq!
$playersfoot
</TABLE>

</TD></TR>
</TABLE>
<BR>
<BR>This page will refresh every $refresh seconds.
<BR>
<\!-- Pretty please keep the following lines displaying on your page, I don't ask much for this free script -->
<BR>Use <A HREF="http://www.dogsbody.org/ut2003/query.html" TARGET="blank_">this script</A> or these 
<A HREF="http://www.dogsbody.org/ut2003/mappics.html" TARGET="blank_">animated map pictures</A> on your site.
<BR>
<BR>
!;
}


sub error
{
$errortext = $_[0];
print qq!
<CENTER><H1>Error...</H1></CENTER>
<HR WIDTH=75% ALIGN=Center>
<BR>
<BR><CENTER><B>
<BR>$errortext
<BR>
<BR>This page will automatically <A HREF=\"$script\">retry</A> in $refresh seconds.
<BR>
<BR></B></CENTER>
!;
&footer();
exit;
}


